#
# Barpanel "PAGER" plugin
# 
# Copyright (C) 2005 - 2006, Federico Pelloni <federico.pelloni@gmail.com>
# Copyright (C) 2008 Job and Esther Technologies Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

name = "Pager"
description = "Draw a pager on the panel"

import barpanel, gtk, gtk.gdk, wnck

class Plugin(barpanel.Plugin):
    def __init__(self, panel, settings):
        barpanel.Plugin.__init__(self, panel, settings)
        self.set_border_width(3)
        self.screen = wnck.screen_get_default()
        self.screen.connect("workspace-created", lambda s,w: self.resize())
        self.screen.connect("workspace-destroyed", lambda s,w: self.resize())
        self.pager = wnck.Pager(self.screen)
        #rect = gtk.gdk.Rectangle(0, 0, 10, 25)
        #pager.size_allocate(rect)
        #        al = gtk.Alignment(0.5, 0.5, 0, 0)
        #        al.show()
        self.connect("scroll-event", self.__cb_scroll)
        #        self.add(al)
        #        al.add(self.pager)
        self.add(self.pager)
        self.resize()
        self.show_all()
    
    def resize(self):
        ws = self.screen.get_workspace_count()
        #pw, ph = self.panel.get_size()
        height = 24
        width = ws * 32
        rows = 1
        self.pager.set_size_request(width, height)
        #print "size request is %d x %d" % (width, height)
        self.pager.set_n_rows(rows)
    
    def __cb_scroll(self, widget, event):
    	
    	ws = self.screen.get_active_workspace()
    	n = ws.get_number()
    	wc = self.screen.get_workspace_count()
    	
    	if event.direction == gtk.gdk.SCROLL_UP:
    		d = max(0, n-1)
    	elif event.direction == gtk.gdk.SCROLL_DOWN:
    		d = min(wc-1, n+1)
    	
    	new = self.screen.get_workspace(d)
    	new.activate(event.time)
        
        
        
