#
# Barpanel "Window Menu" plugin
# 
# Copyright (C) 2008 Job and Esther Technologies Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

name = "Window Menu"
description = """Window Menu."""

import barpanel, gtk, gobject, os, wnck

class Plugin(barpanel.Plugin):
    def __init__(self, panel, settings):
        if settings == None:
            settings = {}
            settings['icon'] = None
            settings['label'] = None
        icon = settings['icon']
        label = settings['label']
        if icon == None:
            icon = 'window-new'
        barpanel.Plugin.__init__(self, panel, settings)
        btn = gtk.Button()
        btn.set_name("EdgeButton")
        btn.connect("clicked", self.onToggled)
        btn.set_relief(gtk.RELIEF_NONE)
        self.add(btn)
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name(icon)
        box.add(img)
        if label != None and len(label)>0:
            lbl = gtk.Label(label)
            panel.update_font(self, lbl)
            box.add(lbl)
        test = wnck.Selector()
        self.show_all()

    def onToggled(self, btn):
        selector = wnck.Selector()
        selector.show()
